﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Gravity : MonoBehaviour {

    public Rigidbody target;
    public float forceCoef = 1f;
    //public float cutOffRange = 30f;

    public AnimationCurve forceCurve;

    private new Rigidbody rigidbody { get { return GetComponent<Rigidbody>(); } }

    private Vector3 CalculateForce() {
        float m = target.mass;
        float M = rigidbody.mass;
        Vector3 rel = transform.position - target.transform.position;
        float d = rel.magnitude;
        // curve
        Vector3 f = forceCurve.Evaluate(d) * forceCoef / d * rel;
        // distance ^ (-2)
        //Vector3 f = (forceCoef * M * m / d / d) / d * rel;

        return f;
    }

	// Use this for initialization
	void Start () {
		
	}
	
	// Update is called once per frame
	void Update () {
        Vector3 force = CalculateForce();
        target.AddForce(force, ForceMode.Impulse);
        PlayerControl.VisualizeForce(target.transform.position, force, Color.red);
	}
}
